package PScm::Closure;

use strict;
use warnings;
use base qw(PScm);

sub new {
    my ($class, $args, $body, $env) = @_;

    bless {
        args => $args,
        body => $body,
        env  => $env,
    }, $class;
}

sub args { $_[0]->{args}->value }
sub body { $_[0]->{body} }
sub env  { $_[0]->{env} }

sub _apply {
    my ($self, @args) = @_;

    my $extended_env =
      $self->env->Extend([$self->args], [@args]);
    return $self->body->Eval($extended_env);
}

sub as_string {
    my ($self) = @_;
    return PScm::Expr::List->new(
        $self->_symbol,
        $self->{args},
        $self->{body}
    )->as_string;
}

################################
package PScm::Closure::Function;

use base qw(PScm::Closure);

sub Apply {
    my ($self, $form, $env) = @_;

    my @evaluated_args = map { $_->Eval($env) } $form->value;
    return $self->_apply(@evaluated_args);
}

sub _symbol {
    PScm::Expr::Symbol->new('lambda');
}

1;
